pathname = 'd:\eeg adatok teljes elrsi tvonala\';
dirlist = dir(strcat(pathname, '\*.set'));       % a fjlok listjnak beolvassa
filenames = extractfield(dirlist,'name');                                                       % a beolvasott listbl csak a fjlnevek kiszedse
size_dirlist = size(dirlist);                                                                   % a fjl lista mrete

for file_idx=1:size_dirlist(1)                                                                  % vgigmegynk az sszes fjlon
    eegdata = pop_loadset('filename',filenames{file_idx},'filepath',pathname,'loadmode','all');     % eeg adatok betltse
   
    disp 'Filtering and resampling'
    eegdata = pop_eegfiltnew(eegdata, 0.5, 45);     % 0.5 s 45 Hz-es svszrs 
    eegdata = pop_resample(eegdata, 90);            % jramintavteleznk 90 Hz-re
    eegdata = pop_rmbase(eegdata);
    
    %% EOG artifactek kiszedse
    % 1. lps: az algoritmus paramtereinek megllaptsa automatikus
    % mdon
    N = eegdata.pnts*size(eegdata.data,3);
    def_wl_samples = eegdata.srate*0.5*eegdata.nbchan^2;
    if size(eegdata.data,3) > 1,
        def_wl_samples = def_wl_samples-mod(def_wl_samples,eegdata.pnts);
    end
    def_wl_samples = min(def_wl_samples,N);
    def_wl = def_wl_samples/eegdata.srate;
    % 2. lps: meghvjuk az algoritmust
    eegdata = pop_autobsseog(eegdata, def_wl);
    
    %% EMG artifactek kiszedse
    % 1. lps: az algoritmus paramtereinek megllaptsa automatikus
    % mdon    
    N = eegdata.pnts*size(eegdata.data,3);
    def_wl_samples = eegdata.srate*0.02*eegdata.nbchan^2;
    if size(eegdata.data,3) > 1,
     def_wl_samples = def_wl_samples-mod(def_wl_samples,eegdata.pnts);
    end
    def_wl_samples = min(def_wl_samples,N);
    def_wl = def_wl_samples/eegdata.srate; 
    % 2. lps: meghvjuk az algoritmust
    eegdata = pop_autobssemg(eegdata, def_wl);

    pop_saveset(eegdata, 'filename', filenames{file_idx}, 'filepath', strcat(pathname,'\2'), 'savemode', 'onefile');     % lementjk a mdostott adathalmazt
end


disp 'Finished'
disp '--------'




