%% MEGADAND VLTOZK
channel_c3 = 10;  % C3 csatorna szma
channel_c4 = 14;  % C4 csatorna szma
% betlteni kvnt adatok megadsa a bal s jobb kzhez
left_hand_files = { 'fjl1' 'fjl2' '...' };
right_hand_files = { 'fjl1' 'fjl2' '...' };
left_hand_event = 41;
right_hand_event = 51;
% EEG adatok mappja
eegdir = 'd:\teljes elrsi tvonal a fjlokhoz\';

%% inicializls
fft_size = 64;
left_c3_all = [];
left_c4_all = [];
right_c3_all = [];
right_c4_all = [];

%% bal kz betltse
disp 'Loading left hand data...'

left_labels = [];           % oszlyozshoz szksges bal kz cmkk cmkk
left_fft_c3 = [];           % bal kz C3 csatornjnak FFT amplitdi   
left_theta_c3 = [];         % bal kz C3 csatornjnak theta sv energii
left_alpha_c3 = [];         % bal kz C3 csatornjnak alfa sv energii
left_beta_c3 = [];          % bal kz C3 csatornjnak bta sv energii
left_fft_c4 = [];           % bal kz C4 csatornjnak FFT amplitdi   
left_theta_c4 = [];         % bal kz C4 csatornjnak theta sv energii
left_alpha_c4 = [];         % bal kz C4 csatornjnak alfa sv energii
left_beta_c4 = [];          % bal kz C4 csatornjnak bta sv energii  

left_fft_c3_idx = 1;        % bal kz C3 csatornjnak FFT amplitdit trol tmb mretnek trolsa
left_fft_c4_idx = 1;        % bal kz C4 csatornjnak FFT amplitdit trol tmb mretnek trolsa

%% vgig megynk a betlteni kvnt fjlokon, amelyek a bal kzhez tartoznak
for file_idx = 1:length(left_hand_files)    
    eegdata = pop_loadset('filename',left_hand_files{file_idx},'filepath',eegdir,'loadmode','all');   % eeg adatok metltse
    %eegdata = pop_resample(eegdata, 90);        % eeg adatok szrse (nem kell, ha eltte mr szrtnk)
    %eegdata = pop_rmbase(eegdata);

    %% Vgigmegynk minden left_hand_event (alap: 41-42) szakaszon, s kiszmoljuk ablakonknt a relatv FFT-t az adott esemny kezdethez kpest
    for e=1:length(eegdata.event(:))
        if (eegdata.event(e).type == left_hand_event)    % ha az eeg event 41 (bal kzmozgs kezdete), akkor szmolunk
            % kiszedjk a C3 s C4 csatornra az adatokat
            channel_c3_data = eegdata.data(channel_c3,floor(eegdata.event(e).latency):floor(eegdata.event(e+1).latency));            
            channel_c3_data = channel_c3_data - mean(channel_c3_data);
            norm_factor_c3 = max(abs(channel_c3_data));
            channel_c3_data = channel_c3_data / norm_factor_c3;
            left_c3_all = [left_c3_all channel_c3_data];
            channel_c4_data = eegdata.data(channel_c4,floor(eegdata.event(e).latency):floor(eegdata.event(e+1).latency));
            channel_c4_data = channel_c4_data - mean(channel_c4_data);
            norm_factor_c4 = max(abs(channel_c4_data));
            channel_c4_data = channel_c4_data / norm_factor_c4;
            left_c4_all = [left_c4_all channel_c4_data];

            % kiszmoljuk az esemny kezdetn az tlagos FFT-t
            fft_c3_rel = abs(fft((eegdata.data(channel_c3,floor(eegdata.event(e).latency)-0.5*eegdata.srate:floor(eegdata.event(e).latency)+0.0*eegdata.srate)/norm_factor_c3),fft_size));
            fft_c4_rel = abs(fft((eegdata.data(channel_c4,floor(eegdata.event(e).latency)-0.5*eegdata.srate:floor(eegdata.event(e).latency)+0.0*eegdata.srate)/norm_factor_c4),fft_size)); 
 

            % az adott 41-42 esemny idtartmra kiszmoljuk a relatv
            % FFT-ket, valamint sszestjk a theta, alfa s bta sv
            % energikat
            % !!!! Az adatokat nem a 0. idponttl szmojuk, mivel a reakciid miatt nem azonnali a cseleks megvalstsa.
            % !!!! Kiprblhat, hogy ha 1-tl kezdjk az indexelst, akkor
            % rosszabb-e az eredmny.
            for t=90:9:270%45:16:length(channel_c3_data)-fft_size-1
                left_fft_c3(left_fft_c3_idx,:) = abs(fft(channel_c3_data(t:t+(fft_size-1)),fft_size))-fft_c3_rel;       % bal C3 relatv fft rtkek kiszmolsa
                left_theta_c3(left_fft_c3_idx) = rms(left_fft_c3(left_fft_c3_idx,2:5));                 % bal C3 theta sv relatv FFT amplitdk sszestse
                left_alpha_c3(left_fft_c3_idx) = rms(left_fft_c3(left_fft_c3_idx,5:10));                 % bal C3 alfa sv relatv FFT amplitdk sszestse
                left_beta_c3(left_fft_c3_idx) = rms(left_fft_c3(left_fft_c3_idx,11:21));                % bal C3 bta sv relatv FFT amplitdk sszestse
                left_fft_c3_idx = left_fft_c3_idx + 1;                                                  % bal kz C3 csatornjnak FFT amplitdit trol tmb mrett trol index nvelse 
                
                left_fft_c4(left_fft_c4_idx,:) = abs(fft(channel_c4_data(t:t+(fft_size-1)),fft_size))-fft_c4_rel;       % bal C4 relatv fft rtkek kiszmolsa
                left_theta_c4(left_fft_c4_idx) = rms(left_fft_c4(left_fft_c4_idx,2:5));                 % bal C4 theta sv relatv FFT amplitdk sszestse
                left_alpha_c4(left_fft_c4_idx) = rms(left_fft_c4(left_fft_c4_idx,5:10));                 % bal C4 alfa sv relatv FFT amplitdk sszestse
                left_beta_c4(left_fft_c4_idx) = rms(left_fft_c4(left_fft_c4_idx,11:21));                % bal C4 bta sv relatv FFT amplitdk sszestse
                left_fft_c4_idx = left_fft_c4_idx + 1;                                                  % bal kz C4 csatornjnak FFT amplitdit trol tmb mrett trol index nvelse 

                % egybl legyrtjuk a label set-et is az osztlyozshoz
                left_labels = [left_labels 1];
            end
        end
    end
end

%% jobb kz betltse
% ******************
% Itt nincsenek extra kommentek, minden megegyezik a bal kz kdjnak
% kommentjeivel a jobb kzre aktualizlva
% ******************


disp 'Loading right hand data...'

right_labels = [];                  % oszlyozshoz szksges bal kz cmkk cmkk

right_fft_c3 = [];                  % jobb kz C3 csatornjnak FFT amplitdi
right_theta_c3 = [];                % jobb kz C3 csatornjnak theta sv energii
right_alpha_c3 = [];                % jobb kz C3 csatornjnak alfa sv energii
right_beta_c3 = [];                 % jobb kz C3 csatornjnak beta sv energii
right_fft_c4 = [];                  % jobb kz C4 csatornjnak FFT amplitdi
right_theta_c4 = [];                % jobb kz C4 csatornjnak theta sv energii
right_alpha_c4 = [];                % jobb kz C4 csatornjnak alfa sv energii
right_beta_c4 = [];                 % jobb kz C4 csatornjnak beta sv energii

right_fft_c3_idx = 1;               % jobb kz C3 csatornjnak FFT amplitdit trol tmb mretnek trolsa
right_fft_c4_idx = 1;               % jobb kz C4 csatornjnak FFT amplitdit trol tmb mretnek trolsa

%%
for file_idx = 1:length(right_hand_files)
    eegdata = pop_loadset('filename',right_hand_files{file_idx},'filepath',eegdir,'loadmode','all');
    %eegdata = pop_resample(eegdata, 90);
    %eegdata = pop_rmbase(eegdata);


    %% Vgigmegynk minden right_hand_event (alap: 51-52) szakaszon, s kiszmoljuk ablakonknt a relatv FFT-t az adott esemny kezdethez kpest
    for e=1:length(eegdata.event(:))
        if (eegdata.event(e).type == right_hand_event)
            channel_c3_data = eegdata.data(channel_c3,floor(eegdata.event(e).latency):floor(eegdata.event(e+1).latency));
            channel_c3_data = channel_c3_data - mean(channel_c3_data);
            norm_factor_c3 = max(abs(channel_c3_data));
            channel_c3_data = channel_c3_data / norm_factor_c3;
            right_c3_all = [right_c3_all channel_c3_data];
            channel_c4_data = eegdata.data(channel_c4,floor(eegdata.event(e).latency):floor(eegdata.event(e+1).latency));
            channel_c4_data = channel_c4_data - mean(channel_c4_data);
            norm_factor_c4 = max(abs(channel_c4_data));
            channel_c4_data = channel_c4_data / norm_factor_c4;
            right_c4_all = [right_c4_all channel_c4_data];

            % kiszmoljuk az esemny kezdetn az tlagos FFT-t
            fft_c3_rel = abs(fft((eegdata.data(channel_c3,floor(eegdata.event(e).latency)-0.5*eegdata.srate:floor(eegdata.event(e).latency)+0.0*eegdata.srate)/norm_factor_c3),fft_size));
            fft_c4_rel = abs(fft((eegdata.data(channel_c4,floor(eegdata.event(e).latency)-0.5*eegdata.srate:floor(eegdata.event(e).latency)+0.0*eegdata.srate)/norm_factor_c4),fft_size)); 
            
            % az adott 51-52 esemny idtartmra a relatv FFT-k
            for t=90:9:270%45:16:length(channel_c3_data)-(fft_size-1)
                right_fft_c3(right_fft_c3_idx,:) = abs(fft(channel_c3_data(t:t+(fft_size-1)),fft_size))-fft_c3_rel;
                right_theta_c3(right_fft_c3_idx) = rms(right_fft_c3(right_fft_c3_idx,2:5));
                right_alpha_c3(right_fft_c3_idx) = rms(right_fft_c3(right_fft_c3_idx,5:10));
                right_beta_c3(right_fft_c3_idx) = rms(right_fft_c3(right_fft_c3_idx,11:21));
                right_fft_c3_idx = right_fft_c3_idx + 1;
                right_fft_c4(right_fft_c4_idx,:) = abs(fft(channel_c4_data(t:t+(fft_size-1)),fft_size))-fft_c4_rel;
                right_theta_c4(right_fft_c4_idx) = rms(right_fft_c4(right_fft_c4_idx,2:5));
                right_alpha_c4(right_fft_c4_idx) = rms(right_fft_c4(right_fft_c4_idx,5:10));
                right_beta_c4(right_fft_c4_idx) = rms(right_fft_c4(right_fft_c4_idx,11:21));
                right_fft_c4_idx = right_fft_c4_idx + 1;

                % egybl legyrtjuk a label set-et is SVM-hez 
                right_labels = [right_labels 2];            
            end
        end
    end    
end

%%  datasetek ltrehozsa
disp 'Creating datasets...'
dataset = [left_fft_c3(:,2:21) left_fft_c4(:,2:21); right_fft_c3(:,2:21) right_fft_c4(:,2:21)];         % fft amplitdkbl ltrehozott dataset
labels = [left_labels right_labels];                                                                    % cmkk az egyes feature vektorokhoz
dataset2 = [left_theta_c3' left_alpha_c3' left_beta_c3' left_theta_c4' left_alpha_c4' left_beta_c4';right_theta_c3' right_alpha_c3' right_beta_c3' right_theta_c4' right_alpha_c4' right_beta_c4'];     % svonknti energikbl ltrehozott dataset


%% normalizls
size_dataset = size(dataset);
scaled_dataset = dataset;
for i=1:size_dataset(2)
    scaled_dataset(:,i) = rescale(dataset(:,i),-1,1);
end

size_dataset2 = size(dataset2);
scaled_dataset2 = dataset2;
for i=1:size_dataset2(2)
    scaled_dataset2(:,i) = rescale(dataset2(:,i),-1,1);
end

%% SVM
disp 'SVM...'
SVMModel = fitcsvm(dataset,labels,'KernelFunction','rbf','Standardize',true,'KernelScale','auto','KFold',5);            % SVM modell tantsa
acc = 1-kfoldLoss(SVMModel);                                                                                            % SVM osztlyozsi pontossg kinyerse
disp (strcat('Accuracy: ',num2str(acc)))                                                                                % Az osztlyozsi pontossg kirsa
[validationPredictions, validationScores] = kfoldPredict(SVMModel);                                                     % Osztlyozs kimeneti cmkinek ellltsa
confusion_matrix = confusionmat(labels,validationPredictions)                                                           % Tvesztsi mtrix ltrhozsa

%%NN
disp 'NN...'

% NN-hoz szksges cmkk ltrehozsa. Azrt kell, mert eltr attl a
% formtumtl, ami az SVM-nek kell
nn_labels = [];
for i=1:length(labels)
    A = zeros(2,1);
    A(labels(i),1) = 1;
    nn_labels = [nn_labels A];
    clear A;   
end

net = patternnet([10]);                      % hlzat ltrehozsa egy bemeneti, egy (10 neuronbl ll) rejtett s egy kimeneti rteggel
[net,tr] = train(net,dataset',nn_labels);       % a hlzat tantsa

disp 'Finished'